<?php
namespace Teknisa\CADEST\Modules\Produto\Services;

use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\Manager\Doctrine\NameProvider;
use Zeedhi\Framework\DataSource\Manager\SQL\ManagerImpl as DataSourceManager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;

class ProdutoUtilities {

    const DEFAULT_FILTER = array("column"=>"IDPRODATIVPR", "operator"=>"=", "value"=>"T");

    protected $entityManager;
    protected $dataSourceManager;
    protected $environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, DataSourceManager $dataSourceManager,
                                Environment $environment, NewCode $newCode) {
        $this->entityManager = $entityManager;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->newCode = $newCode;
    }

    public function commit() {
        $this->getConnection()->commit();
    }

    public function beginTransaction() {
        $this->getConnection()->beginTransaction();
    }

    public function flush() {
        $this->entityManager->flush();
    }

    public function getConnection() {
        return $this->entityManager->getConnection();
    }

    public function getNrorg() {
        return $this->environment->getNrorgTrab();
    }

    public function getProducts($filter = self::DEFAULT_FILTER) {
        $filterCriteria = new FilterCriteria('produto_produto');
        foreach($filter as $element) {
            $filterCriteria->addCondition($element['column'], $element['operator'], $element['value']);
        }
        $dataSet = $this->dataSourceManager->findBy($filterCriteria);
        return $dataSet;
    }

    public function newCode() {
        return $this->newCode->getCodeByTableName('PRODUTO', $this->getNrorg());
    }

    public function rollback() {
        $this->getConnection()->rollback();
    }

    public function saveInProduto($row) {
        $dataSet = new DataSet('produto', array($row));
        $this->dataSourceManager->persist($dataSet);
    }
    
    
}

